OpenTTD Source: VideoDriver_SDL_Default Class Reference

OpenTTD Source 14.1

Public Member Functions | Protected Member Functions | Private Member Functions
VideoDriver_SDL_Default Class Reference

The SDL video driver using default SDL backend. More...

`#include <sdl2_default_v.h>`

Inheritance diagram for VideoDriver_SDL_Default:

## Public Member Functions
const char * | GetName () const override
| Get the name of this driver. More...
Public Member Functions inherited from VideoDriver_SDL_Base
| VideoDriver_SDL_Base (bool uses_hardware_acceleration=false)
const char * | Start (const StringList &param) override
| Start this driver. More...
void | Stop () override
| Stop this driver.
void | MakeDirty (int left, int top, int width, int height) override
| Mark a particular area dirty. More...
void | MainLoop () override
| Perform the actual drawing.
bool | ChangeResolution (int w, int h) override
| Change the resolution of the window. More...
bool | ToggleFullscreen (bool fullscreen) override
| Change the full screen setting. More...
bool | AfterBlitterChange () override
| Callback invoked after the blitter was changed. More...
bool | ClaimMousePointer () override
void | EditBoxGainedFocus () override
| This is called to indicate that an edit box has gained focus, text input mode should be enabled.
void | EditBoxLostFocus () override
| This is called to indicate that an edit box has lost focus, text input mode should be disabled.
std::vector< int > | GetListOfMonitorRefreshRates () override
| Get a list of refresh rates of each available monitor. More...
const char * | GetInfoString () const override
Public Member Functions inherited from VideoDriver
| VideoDriver (bool uses_hardware_acceleration=false)
virtual void | ToggleVsync ([[maybe_unused]] bool vsync)
| Change the vsync setting. More...
virtual bool | UseSystemCursor ()
| Get whether the mouse cursor is drawn by the video driver. More...
virtual void | PopulateSystemSprites ()
| Populate all sprites in cache.
virtual void | ClearSystemSprites ()
| Clear all cached sprites.
virtual bool | HasGUI () const
| Whether the driver has a graphical user interface with the end user. More...
virtual bool | HasEfficient8Bpp () const
| Has this video driver an efficient code path for palette animated 8-bpp sprites? More...
virtual bool | HasAnimBuffer ()
| Does this video driver support a separate animation buffer in addition to the colour buffer? More...
virtual uint8_t * | GetAnimBuffer ()
| Get a pointer to the animation buffer of the video back-end. More...
virtual int | GetSuggestedUIScale ()
| Get a suggested default GUI scale taking screen DPI into account.
void | QueueOnMainThread (std::function< void()> &&func)
| Queue a function to be called on the main thread with game state lock held and video buffer locked. More...
void | GameLoopPause ()
| Pause the game-loop for a bit, releasing the game-state lock. More...

## Protected Member Functions
bool | AllocateBackingStore (int w, int h, bool force=false) override
| (Re-)create the backing store.
void * | GetVideoPointer () override
| Get a pointer to the video buffer.
void | Paint () override
| Paint the window.
void | ReleaseVideoPointer () override
| Hand video buffer back to the painting backend.
Protected Member Functions inherited from VideoDriver_SDL_Base
Dimension | GetScreenSize () const override
| Get the resolution of the main screen.
void | InputLoop () override
| Handle input logic, is CTRL pressed, should we fast-forward, etc.
bool | LockVideoBuffer () override
| Make sure the video buffer is ready for drawing. More...
void | UnlockVideoBuffer () override
| Unlock a previously locked video buffer.
void | CheckPaletteAnim () override
| Process any pending palette animation.
bool | PollEvent () override
| Process a single system event. More...
void | ClientSizeChanged (int w, int h, bool force)
| Indicate to the driver the client-side might have changed.
virtual bool | CreateMainWindow (uint w, uint h, uint flags=0)
| Create the main window.
Protected Member Functions inherited from VideoDriver
virtual float | GetDPIScale ()
| Get DPI scaling factor of the screen OTTD is displayed on. More...
void | UpdateAutoResolution ()
| Apply resolution auto-detection and clamp to sensible defaults.
void | StartGameThread ()
| Start the loop for game-tick.
void | StopGameThread ()
| Stop the loop for the game-tick. More...
void | Tick ()
| Give the video-driver a tick. More...
void | SleepTillNextTick ()
| Sleep till the next tick is about to happen.
std::chrono::steady_clock::duration | GetGameInterval ()
std::chrono::steady_clock::duration | GetDrawInterval ()
void | DrainCommandQueue ()
| Execute all queued commands.

## Private Member Functions
void | UpdatePalette ()
void | MakePalette ()

## Additional Inherited Members
Public Types inherited from Driver
enum | Type { DT_BEGIN = 0, DT_MUSIC = 0, DT_SOUND, DT_VIDEO, DT_END }
| The type of driver. More...
Static Public Member Functions inherited from VideoDriver
static VideoDriver * | GetInstance ()
| Get the currently active instance of the video driver.
static std::string | GetCaption ()
| Get the caption to use for the game's title bar. More...
Static Protected Member Functions inherited from VideoDriver
static void | GameThreadThunk (VideoDriver *drv)
Protected Attributes inherited from VideoDriver_SDL_Base
struct SDL_Window * | sdl_window
| Main SDL window.
Palette | local_palette
| Current palette to use for drawing.
bool | buffer_locked
| Video buffer was locked by the main thread.
Rect | dirty_rect
| Rectangle encompassing the dirty area of the video buffer.
std::string | driver_info
| Information string about selected driver.
Protected Attributes inherited from VideoDriver
const uint | ALLOWED_DRIFT = 5
| How many times videodriver can miss deadlines without it being overly compensated.
std::chrono::steady_clock::time_point | next_game_tick
std::chrono::steady_clock::time_point | next_draw_tick
bool | fast_forward_key_pressed
| The fast-forward key is being pressed.
bool | fast_forward_via_key
| The fast-forward was enabled by key press.
bool | is_game_threaded
std::thread | game_thread
std::mutex | game_state_mutex
std::mutex | game_thread_wait_mutex
bool | uses_hardware_acceleration

## Detailed Description

The SDL video driver using default SDL backend.

Definition at line 16 of file sdl2_default_v.h.

## Member Function Documentation

## ◆ GetName()

const char* VideoDriver_SDL_Default::GetName | ( |  | ) | const
| inlineoverridevirtual

Get the name of this driver.

Returns
  The name of the driver.

Implements Driver.

Definition at line 18 of file sdl2_default_v.h.

The documentation for this class was generated from the following files:

- src/video/sdl2_default_v.h
- src/video/sdl2_default_v.cpp